---
title: Array.prototype.shift()
slug: Web/JavaScript/Reference/Global_Objects/Array/shift
tags:
  - Array
  - JavaScript
  - Method
  - Prototype
  - Reference
---
<div>{{JSRef}}</div>

<p>The <code><strong>shift()</strong></code> method removes the <strong>first</strong> element from an array and returns that removed element. This method changes the length of the array.</p>

<div>{{EmbedInteractiveExample("pages/js/array-shift.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>arr</var>.shift()</pre>

<h3 id="Return_value">Return value</h3>

<p>The removed element from the array; {{jsxref("undefined")}} if the array is empty.</p>

<h2 id="Description">Description</h2>

<p>The <code>shift</code> method removes the element at the zeroeth index and shifts the values at consecutive indexes down, then returns the removed value. If the {{jsxref("Array.length", "length")}} property is 0, {{jsxref("undefined")}} is returned.</p>

<p><code>shift</code> is intentionally generic; this method can be {{jsxref("Function.call", "called", "", 1)}} or {{jsxref("Function.apply", "applied", "", 1)}} to objects resembling arrays. Objects which do not contain a <code>length</code> property reflecting the last in a series of consecutive, zero-based numerical properties may not behave in any meaningful manner.</p>

<p>{{jsxref("Array.prototype.pop()")}} has similar behavior to <code>shift</code>, but applied to the last element in an array.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Removing_an_element_from_an_array">Removing an element from an array</h3>

<p>The following code displays the <code>myFish</code> array before and after removing its first element. It also displays the removed element:</p>

<pre class="brush: js notranslate">var myFish = ['angel', 'clown', 'mandarin', 'surgeon'];

console.log('myFish before:', JSON.stringify(myFish));
// myFish before: ['angel', 'clown', 'mandarin', 'surgeon']

var shifted = myFish.shift();

console.log('myFish after:', myFish);
// myFish after: ['clown', 'mandarin', 'surgeon']

console.log('Removed this element:', shifted);
// Removed this element: angel
</pre>

<h3 id="Using_shift_method_in_while_loop">Using shift() method in while loop</h3>

<p>The shift() method is often used in condition inside while loop. In the following example every iteration will remove the next element from an array, until it is empty:</p>

<pre class="brush: js notranslate">var names = ["Andrew", "Edward", "Paul", "Chris" ,"John"];

while( (i = names.shift()) !== undefined ) {
    console.log(i);
}
// Andrew, Edward, Paul, Chris, John
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-array.prototype.shift', 'Array.prototype.shift')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Array.shift")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array.prototype.push()")}}</li>
 <li>{{jsxref("Array.prototype.pop()")}}</li>
 <li>{{jsxref("Array.prototype.unshift()")}}</li>
 <li>{{jsxref("Array.prototype.concat()")}}</li>
</ul>
